// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "bkbmps.h"
#include "dialogs.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_DIALOGS_BACK, OnDialogsBack)
	ON_COMMAND(ID_DIALOGS_BRUSH, OnDialogsBrush)
	ON_COMMAND(ID_DIALOGS_CENTER, OnDialogsCenter)
	ON_COMMAND(ID_DIALOGS_TEXT, OnDialogsTransparentText)
	ON_UPDATE_COMMAND_UI(ID_DIALOGS_TEXT, OnUpdateText)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	VERIFY(m_bkBmap.LoadBitmap(IDB_BKBMAP));
	VERIFY(m_bmapBrush.LoadBitmap(IDB_BMAPBRUSH));
	VERIFY(m_bmapCentered.LoadBitmap(IDB_BMAPCENTER));

	m_transparentText= FALSE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar.SetWindowText("Standard");
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// Size the main window to 1/2 screen size and center it
	cs.cy = ::GetSystemMetrics(SM_CYSCREEN) / 2;
	cs.cx = ::GetSystemMetrics(SM_CXSCREEN) / 2;
	cs.y = ((cs.cy * 2) - cs.cy) / 2;
	cs.x = ((cs.cx * 2) - cs.cx) / 2;

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnDialogsBack() 
{
	CBmapDlg bmapDlg;
	bmapDlg.DoModal();
}

void CMainFrame::OnDialogsBrush() 
{
	CBmapBrushDlg bmapbrushDlg;
	bmapbrushDlg.DoModal();
}

void CMainFrame::OnDialogsCenter() 
{
	CBmapCenterDlg bmapcenterDlg;
	bmapcenterDlg.DoModal();
}

void CMainFrame::OnDialogsTransparentText() 
{
	m_transparentText= !m_transparentText;
}

void CMainFrame::OnUpdateText(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_transparentText);
}
